Index: trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp	(revision 333)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/X3dParser.cpp	(revision 364)
@@ -463,6 +463,6 @@
 	
 	VertexContainer vertices;
-	
-	for (int i=0; i < len; i++) 
+	int i;
+	for (i=0; i < len; i++) 
 	{
 		string attrName(StrX(attributes.getName(i)).LocalForm());
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Makefile
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Makefile	(revision 363)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Makefile	(revision 364)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (1.07a) (Qt 3.3.2) on: Tue Nov 01 08:42:16 2005
+# Generated by qmake (1.07a) (Qt 3.3.3) on: Tue Nov  1 09:17:00 2005
 # Project:  preprocessor.pro
 # Template: app
@@ -9,36 +9,43 @@
 ####### Compiler, tools and options
 
-CC		=	cl
-CXX		=	cl
-LEX		= flex
-YACC		= byacc
-CFLAGS	=	-nologo -Zm200 -W0 -MD -O2 -G7 -GX  -DUNICODE -DWIN32 -DQT_DLL -DQT_THREAD_SUPPORT -DQT_NO_DEBUG
-CXXFLAGS	=	-nologo -Zm200 -W0 -MD -O2 -G7 -GX  -DUNICODE -DWIN32 -DQT_DLL -DQT_THREAD_SUPPORT -DQT_NO_DEBUG
-LEXFLAGS	=
-YACCFLAGS	=-d
-INCPATH	=	 -I"..\src" -I"..\support\xerces\include" -I"..\support\zlib\include" -I"..\support\boost" -I"..\support\devil\include" -I"$(QTDIR)\include" -I"d:\gametools\svn\trunk\VUT\GtpVisibilityPreprocessor\src" -I"C:\Qt\3.3.2\mkspecs\win32-msvc.net"
-LINK	=	"c:\Program Files\Microsoft Visual Studio .NET 2003\Vc7\bin\link.exe"
-LFLAGS	=	/NOLOGO /DELAYLOAD:comdlg32.dll /DELAYLOAD:oleaut32.dll /DELAYLOAD:winmm.dll /DELAYLOAD:wsock32.dll /DELAYLOAD:winspool.dll /SUBSYSTEM:CONSOLE /LIBPATH:"../support/xerces/lib" /LIBPATH:"../support/devil/lib" /LIBPATH:"$(QTDIR)\lib"
-LIBS	=	 "qt-mt332.lib" "qtmain.lib" "kernel32.lib" "user32.lib" "gdi32.lib" "comdlg32.lib" "advapi32.lib" "shell32.lib" "ole32.lib" "oleaut32.lib" "uuid.lib" "imm32.lib" "winmm.lib" "wsock32.lib" "winspool.lib" "delayimp.lib" "xerces-c_2.lib" "devil.lib" "ilu.lib" "ilut.lib" "opengl32.lib" "glu32.lib"
-MOC		=	$(QTDIR)\bin\moc.exe
-UIC		=	$(QTDIR)\bin\uic.exe
-QMAKE		=	qmake
-IDC		=	$(QTDIR)\bin\idc.exe
-IDL		=	midl
-ZIP		=	zip -r -9
-COPY_FILE	=       copy
-COPY_DIR	=       copy
-DEL_FILE	=       del
-DEL_DIR	=       rmdir
-MOVE		=       move
-CHK_DIR_EXISTS =	if not exist
-MKDIR		=	mkdir
+CC       = gcc
+CXX      = g++
+LEX      = flex
+YACC     = yacc
+CFLAGS   = -pipe -O2 -fmessage-length=0 -Wall -w -O2 -fmessage-length=0 -Wall -D_REENTRANT  -DQT_NO_DEBUG -DQT_THREAD_SUPPORT
+CXXFLAGS = -pipe -O2 -fmessage-length=0 -Wall -w -O2 -fmessage-length=0 -Wall -D_REENTRANT  -DQT_NO_DEBUG -DQT_THREAD_SUPPORT
+LEXFLAGS = 
+YACCFLAGS= -d
+INCPATH  = -I/usr/lib/qt3/mkspecs/default -I. -I../support/src/xerces-c-src_2_7_0/include -I../src -I../support/xerces/include -I../support/zlib/include -I../support/boost -I../support/devil/include -I/usr/include -I$(QTDIR)/include
+LINK     = g++
+LFLAGS   = 
+LIBS     = $(SUBLIBS) -L/usr/lib64/ -L../support/src/xerces-c-src_2_7_0/lib -L../support/devil/lib -L/usr/lib/qt3/lib64 -L$(QTDIR)/lib64/ -L/usr/X11R6/lib64/ -lxerces-c -lIL -lILU -lILUT -lqt-mt -lXext -lX11 -lm -lpthread
+AR       = ar cqs
+RANLIB   = 
+MOC      = $(QTDIR)/bin/moc
+UIC      = $(QTDIR)/bin/uic
+QMAKE    = qmake
+TAR      = tar -cf
+GZIP     = gzip -9f
+COPY     = cp -f
+COPY_FILE= $(COPY)
+COPY_DIR = $(COPY) -r
 INSTALL_FILE= $(COPY_FILE)
 INSTALL_DIR = $(COPY_DIR)
+DEL_FILE = rm -f
+SYMLINK  = ln -sf
+DEL_DIR  = rmdir
+MOVE     = mv -f
+CHK_DIR_EXISTS= test -d
+MKDIR    = mkdir -p
+
+####### Output directory
+
+OBJECTS_DIR = ./
 
 ####### Files
 
-HEADERS =	Halton.h
-SOURCES =	Preprocessor.cpp \
+HEADERS = Halton.h
+SOURCES = Preprocessor.cpp \
 		SamplingPreprocessor.cpp \
 		ExactPreprocessor.cpp \
@@ -70,70 +77,63 @@
 		ViewCellBsp.cpp \
 		Halton.cpp
-OBJECTS =	Preprocessor.obj \
-		SamplingPreprocessor.obj \
-		ExactPreprocessor.obj \
-		KdTree.obj \
-		Environment.obj \
-		gzstream.obj \
-		common.obj \
-		UnigraphicsParser.obj \
-		X3dExporter.obj \
-		SceneGraph.obj \
-		Material.obj \
-		Matrix4x4.obj \
-		Vector3.obj \
-		AxisAlignedBox3.obj \
-		Ray.obj \
-		main.obj \
-		Mesh.obj \
-		Exporter.obj \
-		Camera.obj \
-		X3dParser.obj \
-		MeshKdTree.obj \
-		Pvs.obj \
-		MutualVisibility.obj \
-		Triangle3.obj \
-		Rectangle3.obj \
-		Plane3.obj \
-		Polygon3.obj \
-		ViewCell.obj \
-		ViewCellBsp.obj \
-		Halton.obj
-FORMS =	
-UICDECLS =	
-UICIMPLS =	
-SRCMOC	=	
-OBJMOC	=	
-DIST	=	
-TARGET	=	preprocessor.exe
-
+OBJECTS = Preprocessor.o \
+		SamplingPreprocessor.o \
+		ExactPreprocessor.o \
+		KdTree.o \
+		Environment.o \
+		gzstream.o \
+		common.o \
+		UnigraphicsParser.o \
+		X3dExporter.o \
+		SceneGraph.o \
+		Material.o \
+		Matrix4x4.o \
+		Vector3.o \
+		AxisAlignedBox3.o \
+		Ray.o \
+		main.o \
+		Mesh.o \
+		Exporter.o \
+		Camera.o \
+		X3dParser.o \
+		MeshKdTree.o \
+		Pvs.o \
+		MutualVisibility.o \
+		Triangle3.o \
+		Rectangle3.o \
+		Plane3.o \
+		Polygon3.o \
+		ViewCell.o \
+		ViewCellBsp.o \
+		Halton.o
+FORMS = 
+UICDECLS = 
+UICIMPLS = 
+SRCMOC   = 
+OBJMOC = 
+DIST	   = preprocessor.pro
+QMAKE_TARGET = preprocessor
+DESTDIR  = 
+TARGET   = preprocessor
+
+first: all
 ####### Implicit rules
 
-.SUFFIXES: .c .cpp .cc .cxx .C
-
-{.}.cpp{}.obj::
-	$(CXX) -c $(CXXFLAGS) $(INCPATH) -Fo @<<
-	$<
-<<
-
-{.}.cc{}.obj::
-	$(CXX) -c $(CXXFLAGS) $(INCPATH) -Fo @<<
-	$<
-<<
-
-{.}.cxx{}.obj::
-	$(CXX) -c $(CXXFLAGS) $(INCPATH) -Fo @<<
-	$<
-<<
-
-{.}.C{}.obj::
-	$(CXX) -c $(CXXFLAGS) $(INCPATH) -Fo @<<
-	$<
-<<
-
-{.}.c{}.obj::
-	$(CC) -c $(CFLAGS) $(INCPATH) -Fo @<<
-	$<
-<<
+.SUFFIXES: .c .o .cpp .cc .cxx .C
+
+.cpp.o:
+	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<
+
+.cc.o:
+	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<
+
+.cxx.o:
+	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<
+
+.C.o:
+	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<
+
+.c.o:
+	$(CC) -c $(CFLAGS) $(INCPATH) -o $@ $<
 
 ####### Build rules
@@ -141,66 +141,43 @@
 all: Makefile $(TARGET)
 
-$(TARGET):  $(UICDECLS) $(OBJECTS) $(OBJMOC) 
-	$(LINK) $(LFLAGS) /OUT:$(TARGET) @<< 
-	  $(OBJECTS) $(OBJMOC) $(LIBS)
-<<
-
+$(TARGET):  $(UICDECLS) $(OBJECTS) $(OBJMOC)  
+	$(LINK) $(LFLAGS) -o $(TARGET) $(OBJECTS) $(OBJMOC) $(OBJCOMP) $(LIBS)
 
 mocables: $(SRCMOC)
-uicables: $(UICIMPLS) $(UICDECLS)
-
-Makefile: preprocessor.pro  C:\Qt\3.3.2\mkspecs\win32-msvc.net\qmake.conf C:\Qt\3.3.2\lib\qtmain.prl
+uicables: $(UICDECLS) $(UICIMPLS)
+
+$(MOC): 
+	( cd $(QTDIR)/src/moc && $(MAKE) )
+
+Makefile: preprocessor.pro  /usr/lib/qt3/mkspecs/default/qmake.conf 
 	$(QMAKE) -o Makefile preprocessor.pro
 qmake: 
 	@$(QMAKE) -o Makefile preprocessor.pro
 
-dist:
-	$(ZIP) preprocessor.zip $(SOURCES) $(HEADERS) $(DIST) $(FORMS) d:/gametools/svn/trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro C:\Qt\3.3.2\lib\qtmain.prl  
+dist: 
+	@mkdir -p .tmp/preprocessor && $(COPY_FILE) --parents $(SOURCES) $(HEADERS) $(FORMS) $(DIST) .tmp/preprocessor/ && ( cd `dirname .tmp/preprocessor` && $(TAR) preprocessor.tar preprocessor && $(GZIP) preprocessor.tar ) && $(MOVE) `dirname .tmp/preprocessor`/preprocessor.tar.gz . && $(DEL_FILE) -r .tmp/preprocessor
+
+mocclean:
 
 uiclean:
-mocclean:
-clean: uiclean mocclean
-	-$(DEL_FILE) Preprocessor.obj
-	-$(DEL_FILE) SamplingPreprocessor.obj
-	-$(DEL_FILE) ExactPreprocessor.obj
-	-$(DEL_FILE) KdTree.obj
-	-$(DEL_FILE) Environment.obj
-	-$(DEL_FILE) gzstream.obj
-	-$(DEL_FILE) common.obj
-	-$(DEL_FILE) UnigraphicsParser.obj
-	-$(DEL_FILE) X3dExporter.obj
-	-$(DEL_FILE) SceneGraph.obj
-	-$(DEL_FILE) Material.obj
-	-$(DEL_FILE) Matrix4x4.obj
-	-$(DEL_FILE) Vector3.obj
-	-$(DEL_FILE) AxisAlignedBox3.obj
-	-$(DEL_FILE) Ray.obj
-	-$(DEL_FILE) main.obj
-	-$(DEL_FILE) Mesh.obj
-	-$(DEL_FILE) Exporter.obj
-	-$(DEL_FILE) Camera.obj
-	-$(DEL_FILE) X3dParser.obj
-	-$(DEL_FILE) MeshKdTree.obj
-	-$(DEL_FILE) Pvs.obj
-	-$(DEL_FILE) MutualVisibility.obj
-	-$(DEL_FILE) Triangle3.obj
-	-$(DEL_FILE) Rectangle3.obj
-	-$(DEL_FILE) Plane3.obj
-	-$(DEL_FILE) Polygon3.obj
-	-$(DEL_FILE) ViewCell.obj
-	-$(DEL_FILE) ViewCellBsp.obj
-	-$(DEL_FILE) Halton.obj
-
+
+yaccclean:
+lexclean:
+clean:
+	-$(DEL_FILE) $(OBJECTS)
+	-$(DEL_FILE) *~ core *.core
+
+
+####### Sub-libraries
+
+distclean: clean
+	-$(DEL_FILE) $(TARGET) $(TARGET)
 
 
 FORCE:
 
-distclean: clean
-	-$(DEL_FILE) $(TARGET)
-
 ####### Compile
 
-Preprocessor.obj: Preprocessor.cpp  \
-		SceneGraph.h \
+Preprocessor.o: Preprocessor.cpp SceneGraph.h \
 		Exporter.h \
 		UnigraphicsParser.h \
@@ -223,9 +200,7 @@
 		Intersectable.h \
 		Pvs.h \
-		Ray.h \
-		
-
-SamplingPreprocessor.obj: SamplingPreprocessor.cpp  \
-		SceneGraph.h \
+		Ray.h
+
+SamplingPreprocessor.o: SamplingPreprocessor.cpp SceneGraph.h \
 		KdTree.h \
 		SamplingPreprocessor.h \
@@ -249,9 +224,7 @@
 		Intersectable.h \
 		Material.h \
-		Exporter.h \
-		
-
-ExactPreprocessor.obj: ExactPreprocessor.cpp  \
-		ExactPreprocessor.h \
+		Exporter.h
+
+ExactPreprocessor.o: ExactPreprocessor.cpp ExactPreprocessor.h \
 		Preprocessor.h \
 		Containers.h \
@@ -269,41 +242,31 @@
 		Vector3.h \
 		common.h \
-		Ray.h \
-		
-
-KdTree.obj: KdTree.cpp  \
+		Ray.h
+
+KdTree.o: KdTree.cpp Environment.h \
+		Mesh.h \
+		KdTree.h \
+		common.h \
+		Intersectable.h \
+		Plane3.h \
+		Matrix4x4.h \
+		AxisAlignedBox3.h \
+		Material.h \
+		Pvs.h \
+		Rectangle3.h \
+		Vector3.h \
+		Containers.h \
+		Ray.h
+
+Environment.o: Environment.cpp gzstream.h \
+		common.h \
 		Environment.h \
-		Mesh.h \
-		KdTree.h \
-		common.h \
-		Intersectable.h \
-		Plane3.h \
-		Matrix4x4.h \
-		AxisAlignedBox3.h \
-		Material.h \
-		Pvs.h \
-		Rectangle3.h \
-		Vector3.h \
-		Containers.h \
-		Ray.h \
-		
-
-Environment.obj: Environment.cpp  \
-		gzstream.h \
-		common.h \
-		Environment.h \
-		Vector3.h \
-		
-
-gzstream.obj: gzstream.cpp  \
-		gzstream.h \
-		
-
-common.obj: common.cpp  \
-		common.h \
-		
-
-UnigraphicsParser.obj: UnigraphicsParser.cpp  \
-		Vector3.h \
+		Vector3.h
+
+gzstream.o: gzstream.cpp gzstream.h
+
+common.o: common.cpp common.h
+
+UnigraphicsParser.o: UnigraphicsParser.cpp Vector3.h \
 		Mesh.h \
 		SceneGraph.h \
@@ -319,9 +282,7 @@
 		Rectangle3.h \
 		Containers.h \
-		Parser.h \
-		
-
-X3dExporter.obj: X3dExporter.cpp  \
-		common.h \
+		Parser.h
+
+X3dExporter.o: X3dExporter.cpp common.h \
 		SceneGraph.h \
 		X3dExporter.h \
@@ -341,9 +302,7 @@
 		Intersectable.h \
 		Pvs.h \
-		Ray.h \
-		
-
-SceneGraph.obj: SceneGraph.cpp  \
-		SceneGraph.h \
+		Ray.h
+
+SceneGraph.o: SceneGraph.cpp SceneGraph.h \
 		X3dExporter.h \
 		Intersectable.h \
@@ -357,27 +316,19 @@
 		Exporter.h \
 		Material.h \
-		Pvs.h \
-		
-
-Material.obj: Material.cpp  \
-		common.h \
-		Material.h \
-		
-
-Matrix4x4.obj: Matrix4x4.cpp  \
-		Matrix4x4.h \
-		Vector3.h \
-		common.h \
-		
-
-Vector3.obj: Vector3.cpp  \
-		Matrix4x4.h \
+		Pvs.h
+
+Material.o: Material.cpp common.h \
+		Material.h
+
+Matrix4x4.o: Matrix4x4.cpp Matrix4x4.h \
+		Vector3.h \
+		common.h
+
+Vector3.o: Vector3.cpp Matrix4x4.h \
 		Vector3.h \
 		Halton.h \
-		common.h \
-		
-
-AxisAlignedBox3.obj: AxisAlignedBox3.cpp  \
-		AxisAlignedBox3.h \
+		common.h
+
+AxisAlignedBox3.o: AxisAlignedBox3.cpp AxisAlignedBox3.h \
 		Ray.h \
 		Polygon3.h \
@@ -391,17 +342,13 @@
 		Intersectable.h \
 		Material.h \
-		Pvs.h \
-		
-
-Ray.obj: Ray.cpp  \
-		Ray.h \
-		Plane3.h \
-		Matrix4x4.h \
-		Vector3.h \
-		common.h \
-		
-
-main.obj: main.cpp  \
-		SamplingPreprocessor.h \
+		Pvs.h
+
+Ray.o: Ray.cpp Ray.h \
+		Plane3.h \
+		Matrix4x4.h \
+		Vector3.h \
+		common.h
+
+main.o: main.cpp SamplingPreprocessor.h \
 		ExactPreprocessor.h \
 		Parser.h \
@@ -429,9 +376,7 @@
 		Vector3.h \
 		common.h \
-		Ray.h \
-		
-
-Mesh.obj: Mesh.cpp  \
-		Ray.h \
+		Ray.h
+
+Mesh.o: Mesh.cpp Ray.h \
 		Mesh.h \
 		MeshKdTree.h \
@@ -446,34 +391,28 @@
 		Pvs.h \
 		Rectangle3.h \
-		Containers.h \
-		
-
-Exporter.obj: Exporter.cpp  \
-		X3dExporter.h \
-		Exporter.h \
-		Containers.h \
-		Material.h \
-		
-
-Camera.obj: Camera.cpp  \
-		Camera.h \
-		Ray.h \
-		KdTree.h \
-		Mesh.h \
-		Exporter.h \
-		Vector3.h \
-		AxisAlignedBox3.h \
-		common.h \
-		Rectangle3.h \
-		Matrix4x4.h \
-		Plane3.h \
-		Containers.h \
-		Pvs.h \
-		Intersectable.h \
-		Material.h \
-		
-
-X3dParser.obj: X3dParser.cpp  \
-		X3dParser.h \
+		Containers.h
+
+Exporter.o: Exporter.cpp X3dExporter.h \
+		Exporter.h \
+		Containers.h \
+		Material.h
+
+Camera.o: Camera.cpp Camera.h \
+		Ray.h \
+		KdTree.h \
+		Mesh.h \
+		Exporter.h \
+		Vector3.h \
+		AxisAlignedBox3.h \
+		common.h \
+		Rectangle3.h \
+		Matrix4x4.h \
+		Plane3.h \
+		Containers.h \
+		Pvs.h \
+		Intersectable.h \
+		Material.h
+
+X3dParser.o: X3dParser.cpp X3dParser.h \
 		X3dParserXerces.h \
 		Mesh.h \
@@ -492,9 +431,7 @@
 		Vector3.h \
 		common.h \
-		Ray.h \
-		
-
-MeshKdTree.obj: MeshKdTree.cpp  \
-		Environment.h \
+		Ray.h
+
+MeshKdTree.o: MeshKdTree.cpp Environment.h \
 		Mesh.h \
 		MeshKdTree.h \
@@ -509,13 +446,9 @@
 		Vector3.h \
 		Containers.h \
-		Ray.h \
-		
-
-Pvs.obj: Pvs.cpp  \
-		Pvs.h \
-		
-
-MutualVisibility.obj: MutualVisibility.cpp  \
-		KdTree.h \
+		Ray.h
+
+Pvs.o: Pvs.cpp Pvs.h
+
+MutualVisibility.o: MutualVisibility.cpp KdTree.h \
 		AxisAlignedBox3.h \
 		Ray.h \
@@ -533,45 +466,35 @@
 		common.h \
 		Material.h \
-		Intersectable.h \
-		
-
-Triangle3.obj: Triangle3.cpp  \
-		Triangle3.h \
-		Vector3.h \
-		common.h \
-		
-
-Rectangle3.obj: Rectangle3.cpp  \
-		Rectangle3.h \
-		Vector3.h \
-		common.h \
-		
-
-Plane3.obj: Plane3.cpp  \
-		Plane3.h \
-		Matrix4x4.h \
-		Vector3.h \
-		common.h \
-		
-
-Polygon3.obj: Polygon3.cpp  \
-		Polygon3.h \
-		Mesh.h \
-		ViewCellBsp.h \
-		AxisAlignedBox3.h \
-		Ray.h \
-		Containers.h \
-		Intersectable.h \
-		Plane3.h \
-		Matrix4x4.h \
-		Material.h \
-		Pvs.h \
-		Rectangle3.h \
-		Vector3.h \
-		common.h \
-		
-
-ViewCell.obj: ViewCell.cpp  \
-		ViewCell.h \
+		Intersectable.h
+
+Triangle3.o: Triangle3.cpp Triangle3.h \
+		Vector3.h \
+		common.h
+
+Rectangle3.o: Rectangle3.cpp Rectangle3.h \
+		Vector3.h \
+		common.h
+
+Plane3.o: Plane3.cpp Plane3.h \
+		Matrix4x4.h \
+		Vector3.h \
+		common.h
+
+Polygon3.o: Polygon3.cpp Polygon3.h \
+		Mesh.h \
+		ViewCellBsp.h \
+		AxisAlignedBox3.h \
+		Ray.h \
+		Containers.h \
+		Intersectable.h \
+		Plane3.h \
+		Matrix4x4.h \
+		Material.h \
+		Pvs.h \
+		Rectangle3.h \
+		Vector3.h \
+		common.h
+
+ViewCell.o: ViewCell.cpp ViewCell.h \
 		Mesh.h \
 		Intersectable.h \
@@ -587,9 +510,7 @@
 		Rectangle3.h \
 		Vector3.h \
-		common.h \
-		
-
-ViewCellBsp.obj: ViewCellBsp.cpp  \
-		Plane3.h \
+		common.h
+
+ViewCellBsp.o: ViewCellBsp.cpp Plane3.h \
 		ViewCellBsp.h \
 		Mesh.h \
@@ -607,10 +528,7 @@
 		Material.h \
 		Pvs.h \
-		Rectangle3.h \
-		
-
-Halton.obj: Halton.cpp  \
-		Halton.h \
-		
+		Rectangle3.h
+
+Halton.o: Halton.cpp Halton.h
 
 ####### Install
Index: trunk/VUT/GtpVisibilityPreprocessor/src/default.env
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/default.env	(revision 363)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/default.env	(revision 364)
@@ -9,8 +9,8 @@
 #	filename vienna.x3d
 #	filename ../data/vienna/vienna-simple.x3d
-	filename ../data/vienna/vienna-buildings.x3d
-#	filename ../data/vienna/viewcells-25-sel.x3d
+#	filename ../data/vienna/vienna-buildings.x3d
+#filename ../data/vienna/viewcells-25-sel.x3d
 #	filename ../data/atlanta/atlanta2.x3d
-#	filename ../data/soda/soda.dat
+	filename ../data/soda/soda.dat
 #	filename ../data/soda/soda5.dat
 }
@@ -124,5 +124,5 @@
 	
 	Termination {
-		# autopartition
+	# autopartition
 		maxRays 80
 		maxPolygons 0
Index: trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro	(revision 354)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro	(revision 364)
@@ -6,7 +6,11 @@
 #win32:INCLUDEPATH += c:/STLport-4.6.2/stlport
 
-INCLUDEPATH += ../src ../support/xerces/include  ../support/zlib/include ../support/boost ../support/devil/include
+unix:INCLUDEPATH += ../support/src/xerces-c-src_2_7_0/include
+
+INCLUDEPATH += ../src  ../support/xerces/include  ../support/zlib/include ../support/boost ../support/devil/include
+
 
 win32:LIBPATH += ../support/xerces/lib ../support/devil/lib
+unix:LIBPATH += ../support/src/xerces-c-src_2_7_0/lib ../support/devil/lib /usr/lib/qt3/lib64
 
 #win32:LIBPATH += c:/STLport-4.6.2/lib
@@ -21,4 +25,5 @@
 
 win32:LIBS += xerces-c_2.lib devil.lib ilu.lib ilut.lib
+unix:LIBS += -lxerces-c -lIL -lILU -lILUT
 
 # Input